//
//  AEClient.m
//  Client
//
//  Created by howiieque on 5/1/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "AEClient.h"

@protocol AEMessageServerProtocol

- (oneway void)addMessageClient:(id)client;
- (BOOL)removeMessageClient:(id)client;
- (oneway void)broadcastMessage:(NSString *)string;

@end

@implementation AEClient

- (oneway void)appendMessage:(NSString *)string {
	NSRange appendRange=NSMakeRange([[incoming string] length], 0);
	[incoming replaceCharactersInRange:appendRange withString:string];
	[incoming scrollRangeToVisible:appendRange];
}

- (IBAction)sendMessage:(id)sender {
	[server broadcastMessage:[NSString stringWithFormat:@"%i: %@\n", [[NSProcessInfo processInfo] processIdentifier], [outgoing string]]];
	[outgoing setString:@""];
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
	server=[[NSConnection rootProxyForConnectionWithRegisteredName:@"AEMessageServer" host:nil] retain];
	if(server) {
		[server setProtocolForProxy:@protocol(AEMessageServerProtocol)];
		[server addMessageClient:self];
		[server broadcastMessage:[NSString stringWithFormat:@"Connected: %@ %d\n", [[NSProcessInfo processInfo] processName], [[NSProcessInfo processInfo] processIdentifier]]];
	}
	else
		NSLog(@"Error: Failed to connect to server.");
}

- (void)applicationWillTerminate:(NSNotification *)aNotification {
	//if([server removeMessageClient:self]==NO)
		//NSLog(@"Error: Failed to remove client.");
	[server release];
	server = nil;
}

@end
